#include "FlatShader.hxx"

FlatShader::FlatShader(Scene* scene,
		       const Vec3f& color)
  : Shader(scene),
    m_color(color)
{
}

FlatShader::~FlatShader()
{
}

FlatShader::FlatShader()
  : Shader(0), 
    m_color(Vec3f())
{
}

Vec3f
FlatShader::Shade(Ray& ray)
{
  return m_color; 
}
