#include "kDTree.hxx"

/*************** kDTreeInnerNode ******************/

kDTreeInnerNode::kDTreeInnerNode(float split,
				 int axis)
  : m_split(split),
    m_axis(axis)
{
}

kDTreeInnerNode::~kDTreeInnerNode()
{
  // think about correct memory management!  
}

kDTreeInnerNode::kDTreeInnerNode()
{
}

kDTreeInnerNode::kDTreeInnerNode(const kDTreeInnerNode& node)
{
  operator=(node);
}

kDTreeInnerNode&
kDTreeInnerNode::operator=(const kDTreeInnerNode& )
{
  return *this;
}

bool
kDTreeInnerNode::Traverse(Ray& ray, float& t0, float& t1)
{
  // implement the traversal of an inner node
  // think about the correct order

  return false;
}

void
kDTreeInnerNode::setChildren(kDTreeNode* left,
			     kDTreeNode* right)
{
  m_children[0] = left;
  m_children[1] = right;
}


/******************** kDTreeLeafNode *******************/

kDTreeLeafNode::kDTreeLeafNode(const std::vector<Primitive*>& prim)
  : m_primitives(prim)
{
  
}

kDTreeLeafNode::~kDTreeLeafNode()
{
}

kDTreeLeafNode::kDTreeLeafNode()
{
}

kDTreeLeafNode::kDTreeLeafNode(const kDTreeLeafNode& node)
{
  operator=(node);
}

kDTreeLeafNode&
kDTreeLeafNode::operator=(const kDTreeLeafNode& )
{
  return *this;
}

bool
kDTreeLeafNode::Traverse(Ray& ray, float& t0, float& t1)
{
  // implement the leaf node traversal here
  return false;
}


/******************** kDTree ***********************/

kDTree::kDTree(const Box& bounds, 
	       const std::vector<Primitive*>& prim)
  : m_root(0), 
    m_bounds(bounds),
    m_maxDepth(20),
    m_minTri(3)
{
  m_root = BuildTree(m_bounds, prim, 0);
}

kDTree::~kDTree()
{
  // think about correct memory management
  delete m_root;
}

kDTree::kDTree()
  : m_root(0),
    m_bounds(Box())
{
}

kDTree::kDTree(const kDTree& tree)
{
  operator=(tree);
}

kDTree&
kDTree::operator=(const kDTree& )
{
  return *this;
}

kDTreeNode*
kDTree::BuildTree(const Box& bounds,
		  const std::vector<Primitive*>& prim, 
		  int depth)
{
  // setup tree structure here
  // these two variables are only here to solve compilation issues!
  float dummy_split = 0.0f;
  int dummy_axis = 0;
  kDTreeInnerNode* node = new kDTreeInnerNode(dummy_split, dummy_axis);

  return node;
}

bool
kDTree::Intersect(Ray& ray)
{
  // implement the tree traversal
  return false;
}
