#ifndef REFLECTIVEEYELIGHTSHADER_HXX
#define REFLECTIVEEYELIGHTSHADER_HXX

#include "EyeLightShader.hxx"

class ReflectiveEyeLightShader : public EyeLightShader
{
public:
  ReflectiveEyeLightShader(Scene* scene, float reflectivity, const Vec3f& color = Vec3f(0.5,0.5,0.5));
  virtual ~ReflectiveEyeLightShader();

  virtual Vec3f Shade(Ray& ray);

protected:
  float m_reflectivity;

private:
  ReflectiveEyeLightShader();
};
#endif
